Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34921)
@@ -2243,11 +8599,11 @@
 sub ProcessMetaData($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = length $$dataPt;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     return 0 unless $dirLen >= 2;
     my $count = Get16u($dataPt, 0);
-    $verbose and $exifTool->VerboseDir('MetaData', $count);
+    $verbose and $et->VerboseDir('MetaData', $count);
     my $i;
     my $pos = 2;
@@ -2260,5 +8616,5 @@
         my $enc  = Get16u($dataPt, $pos + 8);
         my $val  = substr($$dataPt, $pos + 10, $size);
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         if ($tagInfo) {
             # convert language code to ASCII (ignore read-only bit)
@@ -2266,8 +8622,8 @@
             # handle alternate languages
             if ($lang) {
-                my $langInfo = Image::ExifTool::GetLangInfo($tagInfo, $lang);
+                my $langInfo = GetLangInfoQT($et, $tagInfo, $lang);
                 $tagInfo = $langInfo if $langInfo;
             }
-            $verbose and $exifTool->VerboseInfo($tag, $tagInfo,
+            $verbose and $et->VerboseInfo($tag, $tagInfo,
                 Value  => $val,
                 DataPt => $dataPt,
@@ -2276,10 +8632,10 @@
             );
             # convert from UTF-16 BE if necessary
-            $val = $exifTool->Decode($val, 'UCS2') if $enc == 1;
+            $val = $et->Decode($val, 'UCS2') if $enc == 1;
             if ($enc == 0 and $$tagInfo{Unknown}) {
                 # binary data
-                $exifTool->FoundTag($tagInfo, \$val);
+                $et->FoundTag($tagInfo, \$val);
             } else {
-                $exifTool->FoundTag($tagInfo, $val);
+                $et->FoundTag($tagInfo, $val);
             }
         }
@@ -2290,21 +8646,153 @@
 
 #------------------------------------------------------------------------------
-# Process Meta keys and add tags to the ItemList table ('mdta' handler) (ref PH)
+# Process sample description table
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+# (ref https://developer.apple.com/library/content/documentation/QuickTime/QTFF/QTFFChap2/qtff2.html#//apple_ref/doc/uid/TP40000939-CH204-25691)
+sub ProcessSampleDesc($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $pos = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || (length($$dataPt) - $pos);
+    return 0 if $pos + 8 > $dirLen;
+
+    my $num = Get32u($dataPt, 4);   # get number of sample entries in table
+    $pos += 8;
+    my $i;
+    for ($i=0; $i<$num; ++$i) {     # loop through sample entries
+        last if $pos + 8 > $dirLen;
+        my $size = Get32u($dataPt, $pos);
+        last if $pos + $size > $dirLen;
+        $$dirInfo{DirStart} = $pos;
+        $$dirInfo{DirLen} = $size;
+        ProcessHybrid($et, $dirInfo, $tagTablePtr);
+        $pos += $size;
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process hybrid binary data + QuickTime container (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessHybrid($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    # brute-force search for child atoms after first 8 bytes of binary data
+    my $dataPt = $$dirInfo{DataPt};
+    my $dirStart = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || length($$dataPt) - $dirStart;
+    my $end = $dirStart + $dirLen;
+    my $pos = $dirStart + 8;   # skip length/version
+    my $try = $pos;
+    my $childPos;
+
+    while ($pos <= $end - 8) {
+        my $tag = substr($$dataPt, $try+4, 4);
+        # look only for well-behaved tag ID's
+        $tag =~ /[^\w ]/ and $try = ++$pos, next;
+        my $size = Get32u($dataPt, $try);
+        if ($size + $try == $end) {
+            # the atom ends exactly at the end of the parent -- this must be it
+            $childPos = $pos;
+            $$dirInfo{DirLen} = $pos;   # the binary data ends at the first child atom
+            last;
+        }
+        if ($size < 8 or $size + $try > $end - 8) {
+            $try = ++$pos;  # fail.  try next position
+        } else {
+            $try += $size;  # could be another atom following this
+        }
+    }
+    # process binary data
+    $$dirInfo{MixedTags} = 1; # ignore non-integer tag ID's
+    $et->ProcessBinaryData($dirInfo, $tagTablePtr);
+    # process child atoms if found
+    if ($childPos) {
+        $$dirInfo{DirStart} = $childPos;
+        $$dirInfo{DirLen} = $end - $childPos;
+        ProcessMOV($et, $dirInfo, $tagTablePtr);
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process iTunes 'righ' atom (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessRights($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dataPos = $$dirInfo{Base};
+    my $dirLen = length $$dataPt;
+    my $unknown = $$et{OPTIONS}{Unknown} || $$et{OPTIONS}{Verbose};
+    my $pos;
+    $et->VerboseDir('righ', $dirLen / 8);
+    for ($pos = 0; $pos + 8 <= $dirLen; $pos += 8) {
+        my $tag = substr($$dataPt, $pos, 4);
+        last if $tag eq "\0\0\0\0";
+        my $val = substr($$dataPt, $pos + 4, 4);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        unless ($tagInfo) {
+            next unless $unknown;
+            my $name = PrintableTagID($tag);
+            $tagInfo = {
+                Name => "Unknown_$name",
+                Description => "Unknown $name",
+                Unknown => 1,
+            },
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
+        }
+        $val = '0x' . unpack('H*', $val) unless $$tagInfo{Format};
+        $et->HandleTag($tagTablePtr, $tag, $val,
+            DataPt  => $dataPt,
+            DataPos => $dataPos,
+            Start   => $pos + 4,
+            Size    => 4,
+        );
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process iTunes Encoding Params (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessEncodingParams($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dirLen = length $$dataPt;
+    my $pos;
+    $et->VerboseDir('Encoding Params', $dirLen / 8);
+    for ($pos = 0; $pos + 8 <= $dirLen; $pos += 8) {
+        my ($tag, $val) = unpack("x${pos}a4N", $$dataPt);
+        $et->HandleTag($tagTablePtr, $tag, $val);
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Read Meta Keys and add tags to ItemList table ('mdta' handler) (ref PH)
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
 # Returns: 1 on success
 sub ProcessKeys($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    local $_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = length $$dataPt;
     my $out;
-    if ($exifTool->Options('Verbose')) {
-        $exifTool->VerboseDir('Keys');
-        $out = $exifTool->Options('TextOut');
+    if ($et->Options('Verbose')) {
+        $et->VerboseDir('Keys');
+        $out = $et->Options('TextOut');
     }
     my $pos = 8;
     my $index = 1;
-    my $infoTable = GetTagTable('Image::ExifTool::QuickTime::ItemList');
-    my $userTable = GetTagTable('Image::ExifTool::QuickTime::UserData');
+    ++$$et{KeysCount};  # increment key count for this directory
+    my $itemList = GetTagTable('Image::ExifTool::QuickTime::ItemList');
+    my $userData = GetTagTable('Image::ExifTool::QuickTime::UserData');
     while ($pos < $dirLen - 4) {
         my $len = unpack("x${pos}N", $$dataPt);
@@ -2314,42 +8802,61 @@
         my $tag = substr($$dataPt, $pos + 8, $len - 8);
         $tag =~ s/\0.*//s; # truncate at null
-        if ($ns eq 'mdta') {
-            $tag =~ s/^com\.apple\.quicktime\.//;   # remove common apple quicktime domain
-        }
-        next unless $tag;
+        $tag =~ s/^com\.(apple\.quicktime\.)?// if $ns eq 'mdta'; # remove apple quicktime domain
+        $tag = "Tag_$ns" unless $tag;
         # (I have some samples where the tag is a reversed ItemList or UserData tag ID)
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         unless ($tagInfo) {
-            $tagInfo = $exifTool->GetTagInfo($infoTable, $tag);
+            $tagInfo = $et->GetTagInfo($itemList, $tag);
             unless ($tagInfo) {
-                $tagInfo = $exifTool->GetTagInfo($userTable, $tag);
+                $tagInfo = $et->GetTagInfo($userData, $tag);
                 if (not $tagInfo and $tag =~ /^\w{3}\xa9$/) {
                     $tag = pack('N', unpack('V', $tag));
-                    $tagInfo = $exifTool->GetTagInfo($infoTable, $tag);
-                    $tagInfo or $tagInfo = $exifTool->GetTagInfo($userTable, $tag);
+                    $tagInfo = $et->GetTagInfo($itemList, $tag);
+                    $tagInfo or $tagInfo = $et->GetTagInfo($userData, $tag);
                 }
             }
         }
-        my $newInfo;
+        my ($newInfo, $msg);
         if ($tagInfo) {
+            # copy tag information into new Keys tag
             $newInfo = {
                 Name      => $$tagInfo{Name},
                 Format    => $$tagInfo{Format},
                 ValueConv => $$tagInfo{ValueConv},
+                ValueConvInv => $$tagInfo{ValueConvInv},
                 PrintConv => $$tagInfo{PrintConv},
+                PrintConvInv => $$tagInfo{PrintConvInv},
+                Writable  => defined $$tagInfo{Writable} ? $$tagInfo{Writable} : 1,
+                SubDirectory => $$tagInfo{SubDirectory},
             };
             my $groups = $$tagInfo{Groups};
-            $$newInfo{Groups} = { %$groups } if $groups;
-        } elsif ($tag =~ /^[-\w.]+$/) {
+            $$newInfo{Groups} = $groups ? { %$groups } : { };
+            $$newInfo{Groups}{$_} or $$newInfo{Groups}{$_} = $$tagTablePtr{GROUPS}{$_} foreach 0..2;
+            $$newInfo{Groups}{1} = 'Keys';
+        } elsif ($tag =~ /^[-\w. ]+$/ or $tag =~ /\w{4}/) {
             # create info for tags with reasonable id's
-            my $name = $tag;
-            $name =~ s/\.(.)/\U$1/g;
-            $newInfo = { Name => ucfirst($name) };
+            my $name = ucfirst $tag;
+            $name =~ tr/-0-9a-zA-Z_. //dc;
+            $name =~ s/[. ]+(.?)/\U$1/g;
+            $name =~ s/_([a-z])/_\U$1/g;
+            $name =~ s/([a-z])_([A-Z])/$1$2/g;
+            $name = "Tag_$name" if length $name < 2;
+            $newInfo = { Name => $name, Groups => { 1 => 'Keys' } };
+            $msg = ' (Unknown)';
         }
         # substitute this tag in the ItemList table with the given index
-        delete $$infoTable{$index};
+        my $id = $$et{KeysCount} . '.' . $index;
+        if (ref $$itemList{$id} eq 'HASH') {
+            # delete other languages too if they exist
+            my $oldInfo = $$itemList{$id};
+            if ($$oldInfo{OtherLang}) {
+                delete $$itemList{$_} foreach @{$$oldInfo{OtherLang}};
+            }
+            delete $$itemList{$id};
+        }
         if ($newInfo) {
-            Image::ExifTool::AddTagToTable($infoTable, $index, $newInfo);
-            $out and printf $out "%sAdded ItemList Tag 0x%.4x = $tag\n", $exifTool->{INDENT}, $index;
+            AddTagToTable($itemList, $id, $newInfo);
+            $msg or $msg = '';
+            $out and print $out "$$et{INDENT}Added ItemList Tag $id = ($ns) $tag$msg\n";
         }
         $pos += $len;
@@ -2360,4 +8867,16 @@
 
 #------------------------------------------------------------------------------
+# Process keys in MetaSampleDesc directory
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessMetaKeys($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    # save this information to decode timed metadata samples when ExtractEmbedded is used
+    SaveMetaKeys($et, $dirInfo, $tagTablePtr) if $$et{OPTIONS}{ExtractEmbedded};
+    return 1;
+}
+
+#------------------------------------------------------------------------------
 # Process a QuickTime atom
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) optional tag table ref
@@ -2365,13 +8884,29 @@
 sub ProcessMOV($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    local $_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
     my $dataPt = $$dirInfo{DataPt};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
+    my $validate = $$et{OPTIONS}{Validate};
     my $dataPos = $$dirInfo{Base} || 0;
-    my ($buff, $tag, $size, $track);
-
+    my $dirID = $$dirInfo{DirID} || '';
+    my $charsetQuickTime = $et->Options('CharsetQuickTime');
+    my ($buff, $tag, $size, $track, $isUserData, %triplet, $doDefaultLang, $index);
+    my ($dirEnd, $unkOpt, %saveOptions, $atomCount);
+
+    my $topLevel = not $$et{InQuickTime};
+    $$et{InQuickTime} = 1;
+    $$et{HandlerType} = $$et{MetaFormat} = '' unless defined $$et{HandlerType};
+
+    unless (defined $$et{KeysCount}) {
+        $$et{KeysCount} = 0;    # initialize ItemList key directory count
+        $doDefaultLang = 1;     # flag to generate default language tags
+    }
     # more convenient to package data as a RandomAccess file
-    $raf or $raf = new File::RandomAccess($dataPt);
+    unless ($raf) {
+        $raf = new File::RandomAccess($dataPt);
+        $dirEnd = $dataPos + $$dirInfo{DirLen} + ($$dirInfo{DirStart} || 0) if $$dirInfo{DirLen};
+    }
     # skip leading bytes if necessary
     if ($$dirInfo{DirStart}) {
@@ -2382,63 +8917,150 @@
     $raf->Read($buff,8) == 8 or return 0;
     $dataPos += 8;
-    $tagTablePtr or $tagTablePtr = GetTagTable('Image::ExifTool::QuickTime::Main');
+    if ($tagTablePtr) {
+        $isUserData = ($tagTablePtr eq \%Image::ExifTool::QuickTime::UserData);
+    } else {
+        $tagTablePtr = GetTagTable('Image::ExifTool::QuickTime::Main');
+    }
     ($size, $tag) = unpack('Na4', $buff);
     if ($dataPt) {
-        $verbose and $exifTool->VerboseDir($$dirInfo{DirName});
+        $verbose and $et->VerboseDir($$dirInfo{DirName});
     } else {
         # check on file type if called with a RAF
         $$tagTablePtr{$tag} or return 0;
-        if ($tag eq 'ftyp') {
-            # read ahead 4 bytes to see what type of file this is
+        if ($tag eq 'ftyp' and $size >= 12) {
+            # read ftyp atom to see what type of file this is
             my $fileType;
-            if ($raf->Read($buff, 4) == 4) {
-                $raf->Seek(-4, 1);
+            if ($raf->Read($buff, $size-8) == $size-8) {
+                $raf->Seek(-($size-8), 1);
+                my $type = substr($buff, 0, 4);
                 # see if we know the extension for this file type
-                $fileType = $1 if $ftypLookup{$buff} and $ftypLookup{$buff} =~ /\(\.(\w+)/;
+                if ($ftypLookup{$type} and $ftypLookup{$type} =~ /\(\.(\w+)/) {
+                    $fileType = $1;
+                # check compatible brands
+                } elsif ($buff =~ /^.{8}(.{4})+(mp41|mp42|avc1)/s) {
+                    $fileType = 'MP4';
+                } elsif ($buff =~ /^.{8}(.{4})+(f4v )/s) {
+                    $fileType = 'F4V';
+                } elsif ($buff =~ /^.{8}(.{4})+(qt  )/s) {
+                    $fileType = 'MOV';
+                }
             }
             $fileType or $fileType = 'MP4'; # default to MP4
-            $exifTool->SetFileType($fileType, $mimeLookup{$fileType} || 'video/mp4');
+            $et->SetFileType($fileType, $mimeLookup{$fileType} || 'video/mp4');
+            # temporarily set ExtractEmbedded option for CRX files
+            $saveOptions{ExtractEmbedded} = $et->Options(ExtractEmbedded => 1) if $fileType eq 'CRX';
         } else {
-            $exifTool->SetFileType();       # MOV
+            $et->SetFileType();       # MOV
         }
         SetByteOrder('MM');
+        $$et{PRIORITY_DIR} = 'XMP';   # have XMP take priority
+    }
+    $$raf{NoBuffer} = 1 if $et->Options('FastScan'); # disable buffering in FastScan mode
+
+    my $ee = $$et{OPTIONS}{ExtractEmbedded};
+    if ($ee) {
+        $unkOpt = $$et{OPTIONS}{Unknown};
+        require 'Image/ExifTool/QuickTimeStream.pl';
+    }
+    if ($$tagTablePtr{VARS}) {
+        $index = $$tagTablePtr{VARS}{START_INDEX};
+        $atomCount = $$tagTablePtr{VARS}{ATOM_COUNT};
     }
     for (;;) {
+        my ($eeTag, $ignore);
+        last if defined $atomCount and --$atomCount < 0;
         if ($size < 8) {
-            last if $size == 0;
-            $size == 1 or $exifTool->Warn('Invalid atom size'), last;
-            $raf->Read($buff, 8) == 8 or last;
+            if ($size == 0) {
+                if ($dataPt) {
+                    # a zero size isn't legal for contained atoms, but Canon uses it to
+                    # terminate the CNTH atom (eg. CanonEOS100D.mov), so tolerate it here
+                    my $pos = $raf->Tell() - 4;
+                    $raf->Seek(0,2);
+                    my $str = $$dirInfo{DirName} . ' with ' . ($raf->Tell() - $pos) . ' bytes';
+                    $et->VPrint(0,"$$et{INDENT}\[Terminator found in $str remaining]");
+                } else {
+                    my $t = PrintableTagID($tag,2);
+                    $et->VPrint(0,"$$et{INDENT}Tag '${t}' extends to end of file");
+                }
+                last;
+            }
+            $size == 1 or $et->Warn('Invalid atom size'), last;
+            # read extended atom size
+            $raf->Read($buff, 8) == 8 or $et->Warn('Truncated atom header'), last;
             $dataPos += 8;
             my ($hi, $lo) = unpack('NN', $buff);
-            $size = $lo;
             if ($hi or $lo > 0x7fffffff) {
                 if ($hi > 0x7fffffff) {
-                    $exifTool->Warn('Invalid atom size');
+                    $et->Warn('Invalid atom size');
                     last;
-                } elsif (not $exifTool->Options('LargeFileSupport')) {
-                    $exifTool->Warn('End of processing at large atom (LargeFileSupport not enabled)');
+                } elsif (not $et->Options('LargeFileSupport')) {
+                    $et->Warn('End of processing at large atom (LargeFileSupport not enabled)');
                     last;
                 }
             }
-            $size = $hi * 4294967296 + $lo;
+            $size = $hi * 4294967296 + $lo - 16;
+            $size < 0 and $et->Warn('Invalid extended size'), last;
+        } else {
+            $size -= 8;
         }
-        $size -= 8;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        if ($validate) {
+            $$et{ValidatePath} or $$et{ValidatePath} = { };
+            my $path = join('-', @{$$et{PATH}}, $tag);
+            $path =~ s/-Track-/-$$et{SET_GROUP1}-/ if $$et{SET_GROUP1};
+            if ($$et{ValidatePath}{$path} and not $dupTagOK{$tag} and not $dupDirOK{$dirID}) {
+                my $i = Get32u(\$tag,0);
+                my $str = $i < 255 ? "index $i" : "tag '" . PrintableTagID($tag,2) . "'";
+                $et->WarnOnce("Duplicate $str at " . join('-', @{$$et{PATH}}));
+                $$et{ValidatePath} = { } if $path eq 'MOV-moov'; # avoid warnings for all contained dups
+            }
+            $$et{ValidatePath}{$path} = 1;
+        }
+        if ($isUserData and $$et{SET_GROUP1}) {
+            my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+            # add track name to UserData tags inside tracks
+            $tag = $$et{SET_GROUP1} . $tag;
+            if (not $$tagTablePtr{$tag} and $tagInfo) {
+                my %newInfo = %$tagInfo;
+                foreach ('Name', 'Description') {
+                    next unless $$tagInfo{$_};
+                    $newInfo{$_} = $$et{SET_GROUP1} . $$tagInfo{$_};
+                    $newInfo{$_} =~ s/^(Track\d+)Track/$1/; # remove duplicate "Track" in name
+                }
+                AddTagToTable($tagTablePtr, $tag, \%newInfo);
+            }
+        }
+        # set flag to store additional information for ExtractEmbedded option
+        my $handlerType = $$et{HandlerType};
+        if ($eeBox{$handlerType} and $eeBox{$handlerType}{$tag}) {
+            if ($ee) {
+                # (there is another 'gps ' box with a track log that doesn't contain offsets)
+                if ($tag ne 'gps ' or $eeBox{$handlerType}{$tag} eq $dirID) {
+                    $eeTag = 1;
+                    $$et{OPTIONS}{Unknown} = 1; # temporarily enable "Unknown" option
+                }
+            } elsif ($handlerType ne 'vide' and not $$et{OPTIONS}{Validate}) {
+                EEWarn($et);
+            }
+        } elsif ($ee and $ee > 1 and $eeBox2{$handlerType} and $eeBox2{$handlerType}{$tag}) {
+            $eeTag = 1;
+            $$et{OPTIONS}{Unknown} = 1;
+        }
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+
+        $$et{OPTIONS}{Unknown} = $unkOpt if $eeTag;     # restore Unknown option
+
         # allow numerical tag ID's
         unless ($tagInfo) {
-            my $num = unpack('N', $tag);
-            if ($$tagTablePtr{$num}) {
-                $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $num);
-                $tag = $num;
+            my $id = $$et{KeysCount} . '.' . unpack('N', $tag);
+            if ($$tagTablePtr{$id}) {
+                $tagInfo = $et->GetTagInfo($tagTablePtr, $id);
+                $tag = $id;
             }
         }
         # generate tagInfo if Unknown option set
-        if (not defined $tagInfo and ($exifTool->{OPTIONS}->{Unknown} or
+        if (not defined $tagInfo and ($$et{OPTIONS}{Unknown} or
             $verbose or $tag =~ /^\xa9/))
         {
-            my $name = $tag;
-            my $n = ($name =~ s/([\x00-\x1f\x7f-\xff])/'x'.unpack('H*',$1)/eg);
-            # print in hex if tag is numerical
-            $name = sprintf('0x%.4x',unpack('N',$tag)) if $n > 2;
+            my $name = PrintableTagID($tag,1);
             if ($name =~ /^xa9(.*)/) {
                 $tagInfo = {
@@ -2450,28 +9072,157 @@
                     Name => "Unknown_$name",
                     Description => "Unknown $name",
-                    Unknown => 1,
-                    Binary => 1,
+                    %unknownInfo,
                 };
             }
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
         }
         # save required tag sizes
-        $exifTool->HandleTag($tagTablePtr, "$tag-size", $size) if $$tagTablePtr{"$tag-size"};
-        # load values only if associated with a tag (or verbose) and < 16MB long
-        if ((defined $tagInfo or $verbose) and $size < 0x1000000) {
+        if ($$tagTablePtr{"$tag-size"}) {
+            $et->HandleTag($tagTablePtr, "$tag-size", $size);
+            $et->HandleTag($tagTablePtr, "$tag-offset", $raf->Tell()) if $$tagTablePtr{"$tag-offset"};
+        }
+        # load values only if associated with a tag (or verbose) and not too big
+        if ($size > 0x2000000) {    # start to get worried above 32 MB
+            # check for RIFF trailer (written by Auto-Vox dashcam)
+            if ($buff =~ /^(gpsa|gps0|gsen|gsea)...\0/s) { # (yet seen only gpsa as first record)
+                $et->VPrint(0, "Found RIFF trailer");
+                if ($et->Options('ExtractEmbedded')) {
+                    $raf->Seek(-8, 1) or last;  # seek back to start of trailer
+                    my $tbl = GetTagTable('Image::ExifTool::QuickTime::Stream');
+                    ProcessRIFFTrailer($et, { RAF => $raf }, $tbl);
+                } else {
+                    EEWarn($et);
+                }
+                last;
+            }
+            $ignore = 1;
+            if ($tagInfo and not $$tagInfo{Unknown} and not $eeTag) {
+                my $t = PrintableTagID($tag,2);
+                if ($size > 0x8000000) {
+                    $et->Warn("Skipping '${t}' atom > 128 MB", 1);
+                } else {
+                    $et->Warn("Skipping '${t}' atom > 32 MB", 2) or $ignore = 0;
+                }
+            }
+        }
+        if (defined $tagInfo and not $ignore) {
+            # set document number for this item property if necessary
+            if ($$et{IsItemProperty}) {
+                my $items = $$et{ItemInfo};
+                my ($id, $prop, $docNum, $lowest);
+                my $primary = $$et{PrimaryItem} || 0;
+ItemID:         foreach $id (keys %$items) {
+                    next unless $$items{$id}{Association};
+                    my $item = $$items{$id};
+                    foreach $prop (@{$$item{Association}}) {
+                        next unless $prop == $index;
+                        if ($id == $primary or (not $dontInherit{$tag} and
+                            (not $$item{RefersTo} or $$item{RefersTo}{$primary})))
+                        {
+                            # this is associated with the primary item or an item describing
+                            # the primary item, so consider this part of the main document
+                            undef $docNum;
+                            undef $lowest;
+                            last ItemID;
+                        } elsif ($$item{DocNum}) {
+                            # this property is already associated with an item that has
+                            # an ExifTool document number, so use the lowest associated DocNum
+                            $docNum = $$item{DocNum} if not defined $docNum or $docNum > $$item{DocNum};
+                        } elsif (not defined $lowest or $lowest > $id) {
+                            # keep track of the lowest associated item ID
+                            $lowest = $id;
+                        }
+                    }
+                }
+                if (not defined $docNum and defined $lowest) {
+                    # this is the first time we've seen metadata from this item,
+                    # so use a new document number
+                    $docNum = ++$$et{DOC_COUNT};
+                    $$items{$lowest}{DocNum} = $docNum;
+                }
+                $$et{DOC_NUM} = $docNum;
+            }
             my $val;
-            unless ($raf->Read($val, $size) == $size) {
-                $exifTool->Warn("Truncated '$tag' data");
+            my $missing = $size - $raf->Read($val, $size);
+            if ($missing) {
+                my $t = PrintableTagID($tag,2);
+                $et->Warn("Truncated '${t}' data (missing $missing bytes)");
                 last;
             }
             # use value to get tag info if necessary
-            $tagInfo or $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag, \$val);
+            $tagInfo or $tagInfo = $et->GetTagInfo($tagTablePtr, $tag, \$val);
             my $hasData = ($$dirInfo{HasData} and $val =~ /\0...data\0/s);
             if ($verbose and not $hasData) {
-                $exifTool->VerboseInfo($tag, $tagInfo,
-                    Value => $val,
-                    DataPt => \$val,
+                my $tval;
+                if ($tagInfo and $$tagInfo{Format}) {
+                    $tval = ReadValue(\$val, 0, $$tagInfo{Format}, $$tagInfo{Count}, length($val));
+                }
+                $et->VerboseInfo($tag, $tagInfo,
+                    Value   => $tval,
+                    DataPt  => \$val,
                     DataPos => $dataPos,
+                    Size    => $size,
+                    Format  => $tagInfo ? $$tagInfo{Format} : undef,
+                    Index   => $index,
                 );
+                # print iref item ID numbers
+                if ($dirID eq 'iref') {
+                    my ($id, $count, @to, $i);
+                    if ($$et{ItemRefVersion}) {
+                        ($id, $count, @to) = unpack('NnN*', $val) if length $val >= 10;
+                    } else {
+                        ($id, $count, @to) = unpack('nnn*', $val) if length $val >= 6;
+                    }
+                    defined $id or $id = '<err>', $count = 0;
+                    $id .= " (wrong count: $count)" if $count != @to;
+                    # convert sequential numbers to a range
+                    for ($i=1; $i<@to; ) {
+                        $to[$i-1] =~ /(\d+)$/ and $to[$i] == $1 + 1 or ++$i, next;
+                        $to[$i-1] =~ s/(-.*)?$/-$to[$i]/;
+                        splice @to, $i, 1;
+                    }
+                    $et->VPrint(1, "$$et{INDENT}  Item $id refers to: ",join(',',@to),"\n");
+                }
+            }
+            # extract metadata from stream if ExtractEmbedded option is enabled
+            if ($eeTag) {
+                ParseTag($et, $tag, \$val);
+                # forget this tag if we generated it only for ExtractEmbedded
+                undef $tagInfo if $tagInfo and $$tagInfo{Unknown} and not $unkOpt;
+            }
+
+            # handle iTunesInfo mean/name/data triplets
+            if ($tagInfo and $$tagInfo{Triplet}) {
+                if ($tag eq 'data' and $triplet{mean} and $triplet{name}) {
+                    $tag = $triplet{name};
+                    # add 'mean' to name unless it is 'com.apple.iTunes'
+                    $tag = $triplet{mean} . '/' . $tag unless $triplet{mean} eq 'com.apple.iTunes';
+                    $tagInfo = $et->GetTagInfo($tagTablePtr, $tag, \$val);
+                    unless ($tagInfo) {
+                        my $name = $triplet{name};
+                        my $desc = $name;
+                        $name =~ tr/-_a-zA-Z0-9//dc;
+                        $desc =~ tr/_/ /;
+                        $tagInfo = {
+                            Name => $name,
+                            Description => $desc,
+                        };
+                        AddTagToTable($tagTablePtr, $tag, $tagInfo);
+                    }
+                    # ignore 8-byte header
+                    $val = substr($val, 8) if length($val) >= 8;
+                    unless ($$tagInfo{Format} or $$tagInfo{SubDirectory}) {
+                        # extract as binary if it contains any non-ASCII or control characters
+                        if ($val =~ /[^\x20-\x7e]/) {
+                            my $buff = $val;
+                            $val = \$buff;
+                        }
+                    }
+                    undef %triplet;
+                } else {
+                    undef %triplet if $tag eq 'mean';
+                    $triplet{$tag} = substr($val,4) if length($val) > 4;
+                    undef $tagInfo;  # don't store this tag
+                }
             }
             if ($tagInfo) {
